//traverse
//12：21 不会写。听说这次1=名额减少了，也许这次就只能拿到3=了。
//不知道机房的大家考得怎么样，有些忐忑，希望大家不要像我一样（笑）
//我这个人的脑子比较腐朽，我指的是没有那么"新鲜"，我也羡慕那些只是略微接触一点就能感觉到对方的聪慧的人。简而言之是我太蠢了。这一点是事实，我承认。我经常性地因为自己没有那么聪明而感到挫败，有时也会感到一点奇怪的喜悦感。 
//其实我文化课成绩还不错？在某种程度上来说，至少我希望我的文化课成绩能被别人说还不错。但是无论对于竞赛还是对于文化课 ，考得多好才算好呢？年级第一？我们在用成绩和分数为人赋予偏见的价值， 这是不是正确的呢，是不是在一个注定无法实现绝对公平的世界里对公平做出些许努力呢？还是留给那些聪明的人去回答吧，我太蠢了。
//我虚伪地希望大家都好，无论是竞赛还是文化课。总有人会解出这些我没有解出的问题，总有人能拿到一等，也总有人能在这条竞赛的道路上走的比我更远，我虚伪又由衷地希望大家都好。对于我来说我唯一的选择就只有去文化课了吧，好在这对我而言也并不是什么痛苦的事情，还有人比我更痛苦，听说NOI每年会给银首鼓掌，也许这是好的，但只要一件事物存在排名和分界，这件事物总是残酷的。但自然也是残酷的。或许这一切都是人类社会对自然选择的一种诠释吧。至于选择的结果的好坏，我虚伪又由衷地希望一切都好。
//我想读书。读好多好多好多书。事实上我想读完世界上所有的书，当然这是不可能的，我只是害怕愚蠢。然而愚蠢与否并不是知识量可以决定的，这更多地与智商相关，所以归根结底，我只是想让别人不要以为我"愚蠢"，这是一个完全出于无聊的自尊心的想法。不过，我也并不是那么在意自尊心，更多时候影响我的是别人的看法，别人的看法、经历、见解以及批评和评价对我而言是那么无所谓又那么醒目。所以也许我只是在怀疑我是什么人，我是自己，还是活在别人眼中的什么人？如果我并不是活在别人眼中，又有什么参照物去证明我的存在？笛卡尔说"我思故我在"，我并不是很信服他之所言，但我们应该相信什么呢？我们的经验？理性？上帝？本体？还是更高更虚无的飘渺宇宙呢？那我们应该怀疑些什么？认识？不可知的事物？还是一切呢？好像说的有些多了，希望这段话不要给任何人看见。这只是一个脱产者的碎碎念，我相信很多事物在我们进入社会生产体系后才会有一个更清晰的认知，和一个更麻木的灵魂。
//快结束了，这一切。
//AFOing! in 2024.11.30 
#include<bits/stdc++.h>
using namespace std;
const int N=1e5+10;
const int Mod=1e9+7;
int head[N],nex[N],to[N],cnt,id[N];
int e[N];

int read(){
	int x=0,k=1;char c=getchar(); 
	while(c<'0'||c>'0'){
		if(c=='-') k=-1;
		c=getchar();
	} 
	while(c>='0'&&c<='9'){
		x=(x<<1)+(x<<3)+(c^48);
		c=getchar();
	}
	return x*k;
}

void add(int u,int v,int i){
	cnt++;
	to[cnt]=v;
	nex[cnt]=head[u];
	head[u]=cnt;
	id[cnt]=i;
}

int main()
{
	freopen("traverse.in","r",stdin);
	freopen("traverse.out","w",stdout);
	int c=read(),T=read();
	while(T--){
		memset(e,0,sizeof(e));
		int n=read(),k=read();
		for(int i=1;i<=n-1;i++){
			int u=read(),v=read();
			add(u,v,i),add(v,u,i);
		}
		for(int i=1;i<=k;i++) e[i]=read();
		printf("1\n"); 
	}
	return 0;
}

